import java.io.IOException;
import javax.microedition.lcdui.*;
import javax.microedition.lcdui.game.*;
class LayerManagerAppend extends GameCanvas implements Runnable { 
	  private LayerManager layer_manager;	  
	  private TiledLayer sky_img;
	  private TiledLayer bg_img;
	  private int ani_idx;	  
	  private Sprite hany_img;	  
	  public LayerManagerAppend() throws IOException {		  
	    super(true);	    
	    layer_manager = new LayerManager();
	    int w = getWidth();
	    int h = getHeight();
	    layer_manager.setViewWindow(96, 0, w, h);
 	    createHany("/hanys.png");
	    createBackground("/background_tiles.png");
	    createSky("/sky.png");	    
	    Thread t = new Thread(this);
	    t.start();
	  }
	  private void createHany(String hany_img_file) throws IOException {
		  Image hany = Image.createImage(hany_img_file);
		  hany_img = new Sprite(hany, 48, 48);
		  hany_img.setPosition(96 + (getWidth() - 48) / 2, 197);
		  layer_manager.append(hany_img);
	  }
	  private void createBackground(String background_img_file) throws IOException {
	    Image background = Image.createImage(background_img_file);
	    int[] map = {
	      0, 0, 0, 0, 0, 0, 0, 0,
	      1, 2, 0, 0, 0, 0, 0, 0,
	      3, 3, 2, 0, 0, 0, 5, 0,
	      3, 3, 3, 2, 4, 1, 3, 2,	    
	      6, 6, 6, 6, 6, 6, 6, 6,
	      6, 6, 6, 6, 6, 6, 6, 6
	    };
	    bg_img = new TiledLayer(8, 6, background, 48, 48);
	    bg_img.setPosition(0, 0);
	    for (int i = 0; i < map.length; i++) {
	      int column = i % 8;
	      int row = (i - column) / 8;
	      bg_img.setCell(column, row, map[i]);
	    }
	    ani_idx = bg_img.createAnimatedTile(8);
	    bg_img.setCell(4, 1, ani_idx);
	    bg_img.setCell(5, 0, ani_idx);
	    layer_manager.append(bg_img);
	  }	    
	  private void createSky(String sky_img_file) throws IOException {
	    Image sky = Image.createImage(sky_img_file);
	    sky_img = new TiledLayer(1, 1, sky, sky.getWidth(), sky.getHeight());
	    sky_img.fillCells(0, 0, 1, 1, 1);
	    sky_img.setPosition(0, 0);
	    layer_manager.append(sky_img);
	  }
	  public void run() {
	    int w = getWidth();
	    int h = getHeight();
	    Graphics g = getGraphics();    
	    while (true) {
	    	g.setColor(0xffffff);
	        g.fillRect(0, 0, w, h);	        
	        layer_manager.paint(g, 0, 0);        
	        flushGraphics();	      
	      try {
	    	  Thread.sleep(80); 
	      } catch (InterruptedException ie) {}
	    }
	 }
}