import javax.microedition.lcdui.*;
import javax.microedition.lcdui.game.*;
import java.io.IOException;

class SpriteCollisionCanvas extends GameCanvas implements Runnable {
	private MySprite rocket;
	private MySprite stone;
	private Image rocket_img;
	private Image stone_img;
	private int img_idx;
	private boolean running;
	private final int MOVEING_SIZE = 5;	
	private LayerManager layerManager;
	
	private boolean colliding = false;
		
	public SpriteCollisionCanvas() {
		super(true);
		layerManager = new LayerManager();
		try {
			rocket_img = Image.createImage("/rocket.png");
			stone_img = Image.createImage("/stone.png");
		}catch (IOException e){
			System.out.println("We can't read Image file");
		}
		rocket = new MySprite(rocket_img, 32, 32, getWidth(), getHeight());
		layerManager.append(rocket);
		stone = new MySprite(stone_img, 24, 24, getWidth(), getHeight());
		layerManager.append(stone);
	}	
	public void start() {
		rocket.setRefPixelPosition(getWidth()/2, getHeight()/2);
		stone.setRefPixelPosition(getWidth()/2, getHeight()/2);
		rocket.setDirection(0, -MOVEING_SIZE);
		running = true;
		img_idx = 0;
		Thread t = new Thread(this);
		t.start();
	}
	public void stop() {
		running = false;
	}
	public void run() {
		Graphics g = getGraphics();
		while(running) {
			tick();
			keyEvent(getKeyStates());
			draw_rocket(g);	
				try {
					Thread.sleep(200);
				} catch(InterruptedException e) {
					stop();
				}
		}
	}
	private void tick() {					
		img_idx = (img_idx + 1) % 4;
		rocket.setFrame(img_idx);
		rocket.move();
		colliding = false;
		if(rocket.collidesWith(stone, true)) {
			colliding = true;
		}
	}
	private void keyEvent(int keyStates) {
		if((keyStates & LEFT_PRESSED)!= 0) {
			rocket.setDirection(-MOVEING_SIZE, 0);
			rocket.setTransform(Sprite.TRANS_ROT270);
		} else if((keyStates & RIGHT_PRESSED) != 0) {
			rocket.setDirection(MOVEING_SIZE, 0);
			rocket.setTransform(Sprite.TRANS_ROT90);
		} else if((keyStates & UP_PRESSED) != 0) {
			rocket.setDirection(0, -MOVEING_SIZE);
			rocket.setTransform(Sprite.TRANS_NONE);
		} else if((keyStates & DOWN_PRESSED) != 0) {
			rocket.setDirection(0, MOVEING_SIZE);
			rocket.setTransform(Sprite.TRANS_ROT180);
		}
	}
	private void draw_rocket(Graphics g) {
		if(colliding) {
			g.setColor(0, 0, 255);
		} else {
			g.setColor(255,255, 255);
		}
		g.fillRect(0, 0, getWidth(), getHeight());
		layerManager.paint(g, 0, 0);
		flushGraphics();		
	}
}