import javax.microedition.lcdui.*;

public class ThreadStarClass extends Thread {
	static java.util.Random random = new java.util.Random();
	static int[][] matrix = {{1,-1, -1, 1, 1, 1}, {-1,-1, 1, 1, -1, 1}, null, {1,1,-1,-1,1,-1}, {-1,1,1,-1,-1,-1}};
	static int delay = 20; 
	Image star_image;
	public int top, left, width, height;
	public int posX, posY; 
	public int star_radius = 10;
	public int deltaX, deltaY;
	Canvas canvas;
	public ThreadStarClass(Canvas c, int left, int top, int width, int height) {
		canvas = c; 
		this.left = left;		
		this.top  = top;
		this.width = width - (2 * star_radius + 2);
		this.height = height - (2 * star_radius + 2);		
		this.posX = (random.nextInt()>>>1) % (this.width-20) + 10;
		this.posY = (random.nextInt()>>>1) % (this.height-20) + 10;
		deltaX = random.nextInt() & 1;
		deltaY = random.nextInt() & 1;		
		try {
			star_image = Image.createImage("/star.png");
		} catch(Exception e)	{
			System.out.println("Image Loading Fail");
		}
	}
	public void run() {
		System.out.println("getName= " + Thread.currentThread().getName());
		int right = left + width;
		int bottom = top + height;	
		while (true) {
			int direction = deltaX + deltaY;
			if(direction == 0)	direction = deltaX + 2*deltaY;
			int collision = 0;		  
			if(posX <= left || posX >= right)	collision++;
			if(posY <= top || posY >= bottom) 	collision += 2;
			if(collision != 0) {
				collision = (collision - 1) * 2;
				deltaX = matrix[direction+2][collision];
				deltaY = matrix[direction+2][collision+1];
			}
			posX = posX + deltaX;
			posY = posY + deltaY;
			canvas.repaint();                 
			try	{
				Thread.sleep(delay);
			} catch(InterruptedException e) {  }
		}
	}   
	void setStarPaint(Graphics g) {
	    g.drawImage(star_image,posX,posY,Graphics.TOP|Graphics.LEFT);
	}   
	static void slower() {
		delay += 10;
		if(delay > 100) delay = 100;
	}     
	static void faster() {
		delay -= 10;
		if(delay < 0) delay = 0;
	}
}