import javax.microedition.lcdui.*;
import java.util.*;
public class ThreadSyncCanvas extends Canvas implements Runnable  {
	static Random random; 
	private int index = 0;
	private char[] buffer = new char[10];
	static Thread produce_t;
	static Thread consumer_t;
	private int val;
	private String draw_str= "";
	private Font largeFont;
	   
	public ThreadSyncCanvas() {
		largeFont = Font.getFont(Font.FACE_MONOSPACE, Font.STYLE_BOLD, Font.SIZE_LARGE);
		random = new Random();
		produce_t = new Thread(this, "produce");
		consumer_t = new Thread(this, "consumer");
        produce_t.setPriority(1);
        produce_t.start();
        consumer_t.setPriority(10);
        consumer_t.start();
	}
	public void paint(Graphics g) {
		g.setFont(largeFont);
		g.setColor(0,255,0);
		g.fillRect(0, 0, getWidth(), getHeight());
		g.setColor(255,0,255);
		g.fillRect(getWidth()/2-28, getHeight()/2-49, 57, 98);
		g.setColor(0,0,0);
		g.drawLine(getWidth()/2-30, getHeight()/2-50, getWidth()/2-30, getHeight()/2+50);
		g.drawLine(getWidth()/2+30, getHeight()/2-50, getWidth()/2+30, getHeight()/2+50);
		g.drawLine(getWidth()/2-30, getHeight()/2+50, getWidth()/2+30, getHeight()/2+50);
		
		for(int i = 0; i < index; i++) {
			g.drawChars(buffer, i, 1, getWidth()/2, getHeight()/2+25-(20*i), Graphics.TOP|Graphics.LEFT);
		}
		g.drawString(draw_str, 20, 240, Graphics.TOP|Graphics.LEFT);
	}	
    public void run() {    	
    	char c;
    	for(int i = 0; i < 50; i++) {
    		if(produce_t.getName().equals("produce")) {
    			c = (char)(RANDOM(26) + 'A');
    			push(c);
    			draw_str = "produced: " + c;
    			try {
    				Thread.sleep((int)(RANDOM(5) * 2000));
    			} catch (InterruptedException e) {  }
    		}
    		if(consumer_t.getName().equals("consumer")) {
                try {
                     Thread.sleep((int)(RANDOM(5) * 2000));
                } catch(InterruptedException e) {  }
                c = pop();
                draw_str = "consumed: " + c;
    		}
    	}
    }
    public synchronized char pop() {
    	while(index == 0) {
    		try {
    			this.wait();
    		} catch (InterruptedException e) {  }
    	}
    	this.notify();
    	index--;
        repaint();
        System.out.println(" Consumed: " + buffer[index]);
    	return buffer[index];
    }
    public synchronized void push(char c) {
    	while(index == buffer.length) {
    		try {
    			this.wait();
    		} catch(InterruptedException e) {  }
    	}
    	this.notify();
    	buffer[index] = c;
    	index++;
    	repaint();
    	System.out.println("Produced: " + c);
    }
	public int RANDOM(int no){
		val = random.nextInt()%no;
			if(val < 0) val += no;
		return 	val;
	}
}